#if defined(HAVE_CONFIG_H)	/* Patched by G-HAL */
# include "config.h"
#endif

#include <sys/types.h>
#include <netinet/in.h>

/**/
#include "anthy/settings.h"	/* Patched by G-HAL, Fri,12 Jun,2009 */
#include <anthy/diclib.h>
#include <anthy/xstr.h>
#include <anthy/alloc.h>
#include <anthy/conf.h>
#include "diclib_inner.h"


unsigned int
anthy_dic_ntohl(unsigned int a)
{
  return ntohl(a);
}

unsigned int
anthy_dic_htonl(unsigned int a)
{
  return htonl(a);
}

int
anthy_init_diclib()
{
 #if 0	/* Patched by G-HAL, Mon,01 Dec,2008, Sun,07 Jun,2009, Sat,20 Jun,2009 */
  anthy_do_conf_init();
  if (anthy_init_file_dic() == -1) {
    return -1;
  }
  anthy_init_xchar_tab();
  anthy_init_xstr();
 #else
  int ret;

  anthy_do_conf_init();
  anthy_load_settings_from_systemconf();
 # if defined(USE_ICONV)
  ret = anthy_init_iconv();
  if (0 != ret) {
    return -1;
  }
 # endif
  ret = anthy_init_xchar_tab();
  if (0 != ret) {
    return -1;
  }
  ret = anthy_init_xstr();
  if (0 != ret) {
    return -1;
  }
  ret = anthy_init_file_dic();
  if (0 != ret) {
    return -1;
  }
 #endif
  return 0;
}

void
anthy_quit_diclib()
{
  anthy_quit_allocator();
  anthy_quit_xstr();
  anthy_quit_xchar_tab();	/* Patched by G-HAL, Mon,25 May,2009 */
 #if defined(USE_ICONV)	/* Patched by G-HAL, Sun,07 Jun,2009 */
  anthy_quit_iconv();
 #endif
  anthy_conf_free();
}
/* vim:ts=8 sw=2 nomodified:
 */
