/*
 * ʸζ򸡽Ф롣
 *
 * metawordˤϥӥӥ르ꥺȤ
 *
 * anthy_eval_border() ǻꤵ줿ΰʸʬ䤹
 *
 * Funded by IPA̤Ƨեȥ¤ 2001 10/29
 * Copyright (C) 2000-2003 TABATA Yusuke, UGAWA Tomoharu
 */
#if defined(HAVE_CONFIG_H)	/* Patched by G-HAL */
# include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>

#include "anthy/settings.h"	/* Patched by G-HAL, Sun,19 Apr,2009 */
#include <anthy/alloc.h>
#include <anthy/splitter.h>
#include "src-splitter/lattice.h"	/* Patched by G-HAL, Mon,20 Apr,2009 */
#include "wordborder.h"

static int
border_check(struct meta_word* mw,
	     int from,
	     int border)
{
  if (mw->from < border) {
    /* Ƭʸ椫ϤޤmwʸڤˤԤäꤢäƤʤȥ */
    if (mw->from == from && mw->from + mw->len == border) {
      return 1;
    } else {
      return 0;
    }
  } else {
    /* ʸ̵˻Ѳǽ */
    return 1;
  }
}

/*
 * ƵŪmetawordѲǽå
 */
static void
metaword_constraint_check(struct splitter_context *sc,
			  struct meta_word *mw,
			  int from,
			  int border)
{
  if (!mw) return;

 #if 0		/* Patched by G-HAL, Sun,17 May,2009 */
  if (mw->can_use != unchecked) return;
 #else
  if (unchecked < mw->can_use) {
    return;
  }
 #endif

  switch(anthy_metaword_type_tab[mw->type].check){
  case MW_CHECK_SINGLE:
   #if 0		/* Patched by G-HAL, Fri,26 Jun,2009 */
    mw->can_use = border_check(mw, from, border) ? ok : ng;
   #else
    mw->can_use = border_check(mw, from, border) ? ok : ng_by_border;
   #endif
    break;
  case MW_CHECK_BORDER:
    {
      struct meta_word* mw1 = mw->mw1;
      struct meta_word* mw2 = mw->mw2;

      if (mw1&&mw2&&mw1->from + mw1->len == border) {
	/* 礦ɶܤ˥ޡäƤ */
       #if 0		/* Patched by G-HAL, Fri,26 Jun,2009 */
	mw->can_use = ng;
       #else
	mw->can_use = ng_by_unsuitable;
       #endif
	break;
      }
      if (mw1)
	metaword_constraint_check(sc, mw1, from, border);
      if (mw2)
	metaword_constraint_check(sc, mw2, mw2->from, border);

     #if 0		/* Patched by G-HAL, Sun,17 May,2009 */
      if ((!mw1 || mw1->can_use == ok) && (!mw2 || mw2->can_use == ok)) {
	mw->can_use = ok;
      } else {
	mw->can_use = ng;
      }
     #else
      if (((NULL == mw1) || (ng_by_border <= mw1->can_use)) && ((NULL == mw2) || (ng_by_border <= mw2->can_use))) {
	mw->can_use = border_check(mw, from, border) ? ok : ng_by_border;
      } else {
	mw->can_use = ng;
      }
     #endif
    }
    break;
  case MW_CHECK_WRAP:
   #if 0		/* Patched by G-HAL, Tue,19 May,2009 */
    metaword_constraint_check(sc, mw->mw1, from, border);
    mw->can_use = mw->mw1->can_use;
   #else
    if (border_check(mw, from, border)) {
      mw->can_use = ok;
      mw->mw1->can_use = ok;
    } else {
      mw->can_use = ng_by_border;
      mw->mw1->can_use = ng_by_border;
    }
   #endif
    break;
  case MW_CHECK_NUMBER:
    {
      struct meta_word* itr = mw;
      mw->can_use = ok;

      /* ġʸΰĤǤʸڤޤäƤСʣϻȤʤ */
      for (; itr && itr->type == MW_NUMBER; itr = itr->mw2) {
	struct meta_word* mw1 = itr->mw1;
	if (!border_check(mw1, from, border)) {
         #if 0		/* Patched by G-HAL, Fri,26 Jun,2009 */
	  mw->can_use = ng;
         #else
	  mw->can_use = ng_by_border;
         #endif
	  break;
	}
      }
    }
    break;
  case MW_CHECK_COMPOUND:
    {
      struct meta_word* itr = mw;
      mw->can_use = ok;

      /* ġʸΰĤǤʸڤޤäƤСʣϻȤʤ */
      for (; itr && (itr->type == MW_COMPOUND_HEAD || itr->type == MW_COMPOUND); itr = itr->mw2) {
	struct meta_word* mw1 = itr->mw1;
	if (!border_check(mw1, from, border)) {
         #if 0		/* Patched by G-HAL, Fri,26 Jun,2009 */
	  mw->can_use = ng;
         #else
	  mw->can_use = ng_by_border;
         #endif
	  break;
	}
      }
    }
    break;
  case MW_CHECK_OCHAIRE:
    {
      struct meta_word* mw1;
      if (border_check(mw, from, border)) {
	for (mw1 = mw; mw1; mw1 = mw1->mw1) {
	  mw1->can_use = ok;
	}
      } else {
	for (mw1 = mw; mw1; mw1 = mw1->mw1) {
         #if 0		/* Patched by G-HAL, Fri,26 Jun,2009 */
	  mw1->can_use = ng;
         #else
	  mw1->can_use = ng_by_border;
         #endif
	}
      }
    }
    break;
  case MW_CHECK_NONE:
    break;
  default:
    printf("try to check unknown type of metaword (%d).\n", mw->type);
  }

 #if 1	/* Patched by G-HAL, Fri,01 May,2009, Sun,17 May,2009, Wed,22 Jul,2009 */
  if (eos < mw->can_use) {
    /* °쥰դʸ°
     *	֤ƻФ - 09/04/29 - depgraph: ʸ°
     *	http://vagus.seesaa.net/article/118312626.html
     */
    if (DEP_EOS == mw->dep_class) {
      if (sc->char_count <= (mw->from + mw->len)) {
	/* mw ʸ */
      } else if (sc->word_split_info->seg_border[mw->from + mw->len]) {
	/* mw μϼưǤʸڤꡣ */
      } else if ((MW_learned_min <= mw->type) && (mw->type <= MW_learned_max) && mw->mw1) {
	/* ؽǡڤͤ˻ؼ줿 */
      } else if (0 == ((XCT_HIRA | XCT_KATA) & anthy_get_xchar_type(sc->ce[mw->from + mw->len].c[0]))) {
	/* mw μʸʿ̾ʰʳʶʤɡˡ */
      } else {
	/* mw ʸǤϤʤ */
	mw->can_use = eos;
      }
    }
  }
 #endif
 #if 1	/* Patched by G-HAL, Mon,20 Apr,2009, Fri,26 Jun,2009, Wed,22 Jul,2009 */
  if (ng < mw->can_use) {
    size_t i  = mw->from + 1;
    size_t to = mw->from + mw->len;
    for (; i < to; ++i) {
      if (sc->word_split_info->seg_border[i]) {
	mw->can_use = ng_by_unsuitable;
	break;
      }
    }
  }
 #endif
 #if 1	/* Patched by G-HAL, Wed,22 Jul,2009 */
  return;
 #endif
}

/*
 * ƤmetawordˤĤƻѤǤ뤫ɤå
 */
static void
metaword_constraint_check_all(struct splitter_context *sc,
			      int from, int to,
			      int border)
{
  int i;
  struct word_split_info_cache *info;
  info = sc->word_split_info;

  /* ޤuncheckedˤ */
  for (i = from; i < to; i ++) {
    struct meta_word *mw;
    for (mw = info->cnode[i].mw;
	 mw; mw = mw->next) {
      mw->can_use = unchecked;
    }
  }

  /* ˹줿metawordˤĤƥå */
  for (i = from; i < to; i ++) {
    struct meta_word *mw;
    for (mw = info->cnode[i].mw; mw; mw = mw->next) {
      metaword_constraint_check(sc, mw, from, border);
    }
  }
}

/*
 * ʸᶭޡ
 */
#if 0		/* Patched by G-HAL, Sun,19 Apr,2009 */
void
anthy_eval_border(struct splitter_context *sc, int from, int from2, int to)
#else
void anthy_eval_border( struct splitter_context* sc, int from, int from2, int to, int is_resize )
#endif
{
  struct meta_word *mw;
  int nr;

 #if 1	/* Patched by G-HAL, Sun,19 Apr,2009 - Mon,20 Apr,2009 */
  if (ANTHY_LATTICE_HINTING_NONE != anthy_settings.anthy_mode.lattice.hinting) {
    if (is_resize) {
      hinted_path_by_manual( sc, from2, to );
    } else {
      hinted_path_by_manual( sc, from, to );
    }
  }
 #endif

  /* ʸΤȤΤΤ */
  metaword_constraint_check_all(sc, from, to, from2);

  /* fromfrom2δ֤򥫥Сmeta_word뤫ɤõ
   * СfromϤԤʤfrom2Ϥ򤹤롣
   */
  nr = 0;
  for (mw = sc->word_split_info->cnode[from].mw; mw; mw = mw->next) {
   #if 0		/* Patched by G-HAL, Sun,17 May,2009 */
    if (mw->can_use == ok) {
   #else
    if (ok <= mw->can_use) {
   #endif
      nr ++;
      break;
    }
  }
  if (nr == 0) {
    from = from2;
  }

  /* ʸζꤹ */
  anthy_mark_borders(sc, from, to);
}
/* vim:ts=8 sw=2 nomodified:
 */
