/**@file
 *			Patches for Anthy, by G-HAL
 *@brief	ؽǡ
 *@date		Wed,27 Aug,2008 - Fri,29 Aug,2008
 *@date		Wed,15 Oct,2008
 *@date		Fri,17 Oct,2008
 *@date		Wed,22 Oct,2008
 *@date		Tue,13 Jan,2009
 *@date		Wed,11 Feb,2009
 *@date		Wed,18 Nov,2009
 *@author	Copyright(C)2008-2009 G-HAL
 */
#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#include <stdlib.h>
/*#include <stdio.h>*/
#include <unistd.h>
#include <strings.h>
#include <limits.h>
#include <time.h>
#include <new>

#include <anthy/settings.h>
#include <anthy/record.h>
#include "record_sub.inc"	// extern ̾Τξͤ򤱤١record_sub.c ˤʤä
#include "record_adjustment.h"
#include "heap_t.h"


/** Ρɤɾͤ׻
 *@param[in]		col			׻оݥΡ
 *@return						ɾ͡ʾۤɾ
 */
static anthy_time_t calc_node_score( const struct trie_node* const col )
{
	static const int	Frequency_MagicNumber = 4;
	const anthy_time_t ret
			= (col->timestamp - anthy_settings.timestamp.currentsession)
			/ (col->frequency + Frequency_MagicNumber);
	return (ret < 0) ? ret : 0;
}



/** Ķʬγؽǡκ
 *@param[in]		rst			оݤΥ쥳
 */
void anthy_truncate_record( struct record_stat* const rst )
{
	if (!rst) {
		return;
	}

	anthy_settings.timestamp.currentsession = time(NULL);

	{	HeapT<xstr*,time_t>*	tree = new HeapT<xstr*,time_t>( anthy_settings.section[NONE_SECTION].max_entry );
		struct record_section* sec = rst->section_list.next;
		struct record_section* next_sec;

		for (; sec; sec = next_sec) {
			next_sec = sec->next;
			struct trie_node*	col = trie_first(&sec->cols);
			if (!col) {
				// Υ϶
				continue;
			}

			ssize_t	max_entry = anthy_settings.section[sec->section].max_entry;		// Ĥȥ
			if (max_entry < 0) {
				// ΥϺʤ
				continue;
			} else if (0 == max_entry) {
				// Υ
				free_section(rst, sec);
			} else if (0 < max_entry) {
				size_t	count = max_entry;
				tree->clear();
				for (struct trie_node* next; col; col = next) {
					next = trie_next(&sec->cols, col);
					if ((rst->cur_section == sec) && (rst->cur_row == col)) {
						rst->cur_row = NULL;
					}
					const time_t	cur_score = calc_node_score( col );
					if (0 < count) {
						tree->in( &(col->row.key), cur_score );
						count --;
						/*printf("sec:%d, in: %d, %04x\n", sec->section, col->row.key.len, col->row.key.str[0] );*/
					} else {
						const time_t* const		top_val = tree->top_var();
						if (top_val && (cur_score < (*top_val))) {
							/*printf("sec:%d: %ld < %ld, delete col: %3d, %04x, %ld, %d\n", sec->section, cur_score, *top_val, col->row.key.len, col->row.key.str[0], col->timestamp, col->frequency );*/
							trie_remove( &(sec->cols), &(col->row.key), &(sec->lru_nr_used), &(sec->lru_nr_sused) );
						} else {
							xstr*	key;
							tree->out( &key );
							/*printf("sec:%d: %ld > %ld, delete top: %3d, %04x\n", sec->section, cur_score, *top_val, key->len, key->str[0] );*/
							const int	ret = trie_remove( &(sec->cols), key, &(sec->lru_nr_used), &(sec->lru_nr_sused) );
							tree->in( &(col->row.key), cur_score );
							if (!ret) {
								/*printf("sec:%d, trie_remove() failed. :top\n", sec->section );*/
							}
						}
					}
				}
			}
		}

		delete tree;
	}

	return;
}

/* [ End of File ] */
